Subject: Re: [Bitcoin-development] have there been complains about network congestion? (router crashes, slow internet when running Bitcoin nodes)

From: Gregory Maxwell <[email-masked]>
Date: Tue, 8 Apr 2014 09:44:07 -0700

On Tue, Apr 8, 2014 at 9:13 AM, Angel Leon <[email-masked]> wrote:
> a home router that crashes or slows down when its NAT pin-hole table
> overflows, triggered by many TCP connections.

We don't form or need to form a great many connections.

> a home router that crashes or slows down by UDP traffic

We don't use UDP.

> a home DSL or cable modem having its send buffer filled up by outgoing data,
> and the buffer fits seconds worth of bytes. This adds seconds of delay on
> interactive traffic. For a web site that needs 10 round trips to load this
> may mean 10s of seconds of delay to load compared to without bittorrent.
> Skype or other delay sensitive applications would be affected even more.
>
> These are issues the bittorrent community faced and eventually solved
> brilliantly with uTP, which uses a congestion window algorithm that allows

Yes, TCP has a congestion window too, still sometimes some poorly
designed or configured routers suffer from buffer bloat.

> perhaps uTP could help greatly

Adding our own UDP network stack involving a ton of exposed code
sounds like a great way to gain inadvertent bugs or backdoors.

But there doesn't have to be and shouldn't just be one network
transport for Bitcoin. You can gateway to other protocols and run them
in parallel.  I think it would be great for someone to go build an
alternative transport protocol to gateway to and see what useful
things they can accomplish.